proc domaxima { {m} } {
    set t "display2d:false;\n$m;"
    # return [string range [exec maxima << $t | tail -2  ] 6 end-7]
    return [string range [exec c:/Program\ Files/Maxima-5.12.0/bin/maxima -q << $t ] 32 end-7]
    #return [exec maxima --real-quiet << $t ]
 } 
proc domaximafor { {m} } {
    set t "display2d:false;\nlinel:3000;\nfortran(subst((float(%e)),%e,subst((float(%pi)),%pi,$m)));\n"
    return [string range [exec c:/Program\ Files/Maxima-5.12.0/bin/maxima -q << $t ] 42 end-18]
 } 
proc domaximaformula { {m} } {
    #set t "tex($m);"
    set t "display2d:false;\ntex($m);"
    return [string range [exec c:/Program\ Files/Maxima-5.12.0/bin/maxima -q --very-quiet << $t ] 6 end-6]
 } 
proc domaximagraph { {m} } {
    set t "display2d:false;\nlinel:3000;\nplot2d ($m, \[x, 0, 0.1\], \[gnuplot_term, \"gif size 1600,512\"\], \[gnuplot_out_file, \"gnuplot.gif\"\]);\n"
    return [exec c:/Program\ Files/Maxima-5.12.0/bin/maxima --very-quiet << $t ]
 } 
proc formake { {e} } {
   global f
   set t [subst -nocommand {
      subroutine sayhello(x,r,v)
        double precision x,r,v
        r = $e
        return
      end
   }]
   set f [open sub.f w]
   puts $f [string trim $t \n]
   close $f
#   set env(TMP) /dev/shm/
#   set env(TEMP) /dev/shm/
   # exec gcc -O3 -ffixed-line-length-none -c -o subxp.o sub.f
   exec bash -c "gcc -O3 -ffixed-line-length-none -c -o subxp.o sub.f"
   # exec gcc -O3 -o synthbw.exe synth.c subxp.o -lasound -ljack
   puts stdout [catch {exec bash -c "gcc -O3 -o synthbw.exe -mno-cygwin -o math.exe -I C:/cygwin/home/B.\\ Rosenstok/portaudio/portaudio_v18/pa_common C:/cygwin/home/B.\\ Rosenstok/portaudio/portaudio_v18/pa_common/pa_lib.c C:/cygwin/home/B.\\ Rosenstok/portaudio/portaudio_v18/pa_win_wmme/pa_win_wmme.c mathxp.c subxp.o -lwinmm -lm" }]

#   exec gcc -ffixed-line-length-none -c -o /dev/shm/sub.o /dev/shm/sub.f
#   exec gcc -o /dev/shm/fm /dev/shm/sub.o mw.c wav.o -lm
   #exec gfortran -ffixed-line-length-none -c sub.f
   #exec gcc -o fm sub.o main.c -lm
#   return [exec /dev/shm/fm]
   return 
 } 
proc makeprog { {form} } {
 global makeprogout
 #    cd /dev/shm/S

   set makeprogout ""
   append makeprogout "[clock format [clock seconds]]:\n" 

   append makeprogout "evaluating maxima expression..\n"
   flush stdout
#   append makeprogout "[set in [gets stdin]]<br>--><br>"
   append makeprogout  "[set r [domaxima $form]]\n"
   append makeprogout  "generating Fortran expression from it..\n"
   set s [domaximafor $r]
   append makeprogout  "generating wave..\n"
   append makeprogout  "[formake $s]\n"
   # append makeprogout "making mp3 from wave ..\n"
   # append makeprogout "[exec ffmpeg -i /dev/shm/math.wav -ab 256k -y /dev/shm/math.mp3 >& /dev/null ]\n"
   # append makeprogout "making prettyprinted formula ..\n"
   # doformula [domaximaformula $r]
   # catch {exec ppmquant 256 /dev/shm/sine.ppm | ppmtogif > /dev/shm/graph1.gif 2> /dev/null}

   append makeprogout end\n
# Makes the cgi-bin script stop the server process thinking there's a connection
#   exit
} 

